

#include "allstuff.h"



struct tOPtr {
	tObject *o;
	
	bool operator <(const tOPtr &p) const
	{
		float yp1 = o->yp;
		float yp2 = p.o->yp;
		if(o->id  ==ID_WALL) yp1+=0.8;
		if(p.o->id==ID_WALL) yp2+=0.8;
		if(yp1<yp2) return true;
		if(yp1>yp2) return false;
		return (o->xp<p.o->xp);
	}
};


vector<tObject *> objects;
vector<tObject *> new_objs;
tObject *col_map[25][25];
int stage=0;
int score=0;
int high_score=0;
int app_eaten,app_total;
float stage_text;
int demo_mode=1;
int game_over;
int cheat_mode;



void start_new_game()
{
	stage = 0;
	score = 0;
	demo_mode = 0;
	game_over = 0;
	load_map("test.map");
	cheat_mode = 0;
}

void start_demo_mode()
{
	stage = 0;
	score = 0;
	demo_mode = 1;
	game_over = 0;
	load_map("demo.map");
	cheat_mode = 0;
}


bool check_col(int x,int y,tObject **trg)
{
	if(trg)
		*trg=NULL;
		
	if(x<0 || x>=25 || y<0 || y>=25)
		return true;
		
	if(trg)
		*trg = col_map[x][y];

	return (col_map[x][y]!=NULL);
}

void remove_col(tObject *obj)
{
	int x,y;
	for(x=0;x<25;x++)
		for(y=0;y<25;y++)
			if(col_map[x][y]==obj)
				col_map[x][y]=NULL;
}

void set_col_xy(tObject *obj,int x,int y)
{
	if(x>=0 && x<25 && y>=0 && y<25)
		col_map[x][y]=obj;
}

void set_col(tObject *obj)
{
	remove_col(obj);

	int x1 = int(floor(obj->xp-0.499+0.5));
	int y1 = int(floor(obj->yp-0.499+0.5));
	int x2 = int(floor(obj->xp+0.499+0.5));
	int y2 = int(floor(obj->yp+0.499+0.5));
	
	set_col_xy(obj,x1,y1);
	set_col_xy(obj,x1,y2);
	set_col_xy(obj,x1,y1);
	set_col_xy(obj,x1,y2);
}


tObject *create_object(int id,int xp,int yp)
{
//	if(id==ID_SNAKE ) return NULL;
//	if(id==ID_PLAYER) return NULL;
//	if(id==ID_APPLE ) return NULL;
//	if(id==ID_TROLL ) return NULL;
	
	tObject *obj = new tObject();
	memset(obj,0,sizeof(obj));
	obj->id = id;
	obj->xp = xp;
	obj->yp = yp;

	set_col_xy(obj,xp,yp);

	if(id==ID_APPLE)
	{
		obj->frame = STR2INT("a0");
		obj->think_fun = apple_think;
		app_total++;
	}
	if(id==ID_WALL ) obj->frame = STR2INT("w0");
	if(id==ID_TROLL)
	{
		obj->frame = STR2INT("d0");
		obj->think_fun = troll_think;
	}
	if(id==ID_SNAKE)
	{
		obj->frame = STR2INT("s1");
		obj->state = 10;
		obj->think_fun = snake_think;
	}
	if(id==ID_SNAKE_TAIL)
	{
		obj->frame = STR2INT("t0");
		obj->end_move_fun = snake_tail_end_move;
	}
	if(id==ID_PLAYER)
	{
		obj->frame = STR2INT("a0");
		obj->think_fun = player_think;
	}


	obj->think_time=1.0001;

	new_objs.push_back(obj);

	return obj;
}

void flush_new()
{
	int i;
	for(i=0;i<new_objs.size();i++)
		objects.push_back(new_objs[i]);
	new_objs.clear();
}


void remove_all_objs()
{
	vector<tObject *>::iterator p;
	for(p=objects.begin();p!=objects.end();p++)
		delete *p;
	objects.clear();
	memset(col_map,0,sizeof(col_map));
}


void plant_random(int id)
{
	int x,y,n;
	n=0;
	do
	{
		x=rand()%25;
		y=rand()%25;
		n++;
	} while(col_map[x][y] && n<100);
	if(n<100)
		create_object(id,x,y);
}

void load_map(char *path)
{
	remove_all_objs();

	int na=0,nt=0,ns=0,np=0;

	if(!demo_mode)
	{
		play_samp(0);
		stage++;
		stage_text = 1.0;
		
		na = stage+10;
		if(na>50) na=50;
		
		ns = 1;
		if(stage>=10) ns++;
		if(stage>=20) ns++;
		if(stage>=30) ns++;
		
		nt = 0;
		if(stage>= 2) nt++;
		if(stage>= 5) nt++;
		if(stage>= 8) nt++;
		if(stage>=12) nt++;
		if(stage>=15) nt++;
		if(stage>=18) nt++;

		np = 1;
	}
	else
	{
		ns=1;
		na=25;
	}
	
	int i;
	char map[256];
	for(i=0;i<256;i++)
		map[i]=i;
		
	for(i='A';i<='Z';i++)
	{
		if(rand()%100<50)
		{
			map[i]='#';
			map[i-'A'+'a']='.';
		}
		else
		{
			map[i]='.';
			map[i-'A'+'a']='#';
		}
	}

	app_total=app_eaten=0;
	
	FILE *fp = fopen(path,"rt");
	if(!fp)
		return;
	char buff[1000];
	int x,y=0;
	while(y<25 && fgets(buff,1000,fp))
	{
		for(x=0;x<25 && buff[x];x++)
		{
			buff[x]=map[buff[x]];
			if(buff[x]!=' ' && buff[x]!='.')
				create_object(buff[x],x,y);
		}
		y++;
	}
	
	if(ns>=1) create_object(ID_SNAKE, 0, 0);
	if(ns>=2) create_object(ID_SNAKE,24,24);
	if(ns>=3) create_object(ID_SNAKE, 0,24);
	if(ns>=4) create_object(ID_SNAKE,24, 0);

	for(i=0;i<nt;i++) plant_random(ID_TROLL);
	for(i=0;i<na;i++) plant_random(ID_APPLE);

	for(x=-1;x<26;x++)
	{
		create_object(ID_WALL,x,-1);
		create_object(ID_WALL,x,25);
	}
	for(y=0;y<25;y++)
	{
		create_object(ID_WALL,-1,y);
		create_object(ID_WALL,25,y);
	}
	
	fclose(fp);
	
	flush_new();
}

void show_objects(BITMAP *dest)
{
	tOPtr *op = (tOPtr*)&(objects[0]);
	int os = objects.size();
	if(os>=2)
		sort(op,op+os);
	
	vector<tObject *>::iterator p;
	for(p=objects.begin();p!=objects.end();p++)
	{
		int xp = int((*p)->xp*40+12);
		int yp = int((*p)->yp*30-(*p)->zp*40+9);
		draw_frame(dest,(*p)->frame,xp,yp);
		if((*p)->fr_eye_l) draw_frame(dest,FRAME2INT('e',"1123456789ab"[(*p)->fr_eye_l]),xp,yp);
		if((*p)->fr_eye_r) draw_frame(dest,FRAME2INT('f',"1123456789ab"[(*p)->fr_eye_r]),xp,yp);
		if((*p)->fr_mouth) draw_frame(dest,FRAME2INT('m',"1123456789ab"[(*p)->fr_mouth]),xp,yp);
	}
}

void think_obj(tObject *obj,float delta,int phase)
{
	// move
  if(phase==1)
	if(obj->move_dir!=0 && obj->move_dist>=0.0001)
	{
		float dist = obj->move_speed*delta;
		if(dist>obj->move_dist)
			dist = obj->move_dist;
		obj->xp+=DX[obj->move_dir]*dist;
		obj->yp+=DY[obj->move_dir]*dist;
		if(obj->flags&FL_JUMP_MOVE)
 		{
 			float dx = fabs(obj->xp-floor(obj->xp)-0.5)+0.5;
 			float dy = fabs(obj->yp-floor(obj->yp)-0.5)+0.5;
 			if(dx>dy) dx=dy;
			obj->zp = 3*(dx-dx*dx);
		}
		obj->move_dist-=dist;
		if(obj->move_dist<0.0001 && obj->end_move_fun)
		{
			obj->move_dist=0;
			int xp=int(obj->xp=floor(obj->xp+0.5));
			int yp=int(obj->yp=floor(obj->yp+0.5));
			remove_col(obj);
			set_col_xy(obj,xp,yp);
			obj->end_move_fun(obj);
		}
	}
	
	// think
  if(phase==2)
  {
	if(obj->troll_time>0)
	{
		obj->troll_time-=delta;
		if(obj->troll_time<0)
			obj->troll_time=0;
	}
	if(obj->think_time>0)
	{
		obj->think_time-=delta;
		if(obj->think_time<=0 && obj->think_fun)
			obj->think_fun(obj);
	}
  }
}

void think_objects(float delta)
{
	vector<tObject *>::iterator p;
	
	for(p=objects.begin();p!=objects.end();p++)
		think_obj(*p,delta,1);
		
	for(p=objects.begin();p!=objects.end();p++)
		think_obj(*p,delta,2);
		
	flush_new();
	
	if(stage_text>0)
		stage_text-=delta;
}

bool object_go(tObject *obj,int dir,tObject **oth)
{
	if(oth)
		*oth = NULL;

	if(dir==0)
		return false;

	obj->move_dist=0;
	int xp = int(obj->xp=floor(obj->xp+0.5));
	int yp = int(obj->yp=floor(obj->yp+0.5));
	tObject *other;
	if(check_col(xp+DX[dir],yp+DY[dir],&other))
		if(other!=obj)
		{
			if(oth)
				*oth = other;
			return false;
		}

  	remove_col(obj);
//  	set_col_xy(obj,xp,yp);
  	set_col_xy(obj,xp+DX[dir],yp+DY[dir]);
  	obj->move_dir = dir;
  	obj->move_dist = 1.0;

	return true;
}

void check_endgame()
{
	vector<tObject *>::iterator p;
	int na=0,np=0;

	for(p=objects.begin();p!=objects.end();p++)
	{
		if((*p)->id==ID_APPLE ) na++;
		if((*p)->id==ID_PLAYER) np++;
	}
	
	if(!demo_mode)
	{
		if( (stage&1) && key[KEY_1] && (high_score>=100000)) na=0, cheat_mode=1;
		if(!(stage&1) && key[KEY_2] && (high_score>=100000)) na=0, cheat_mode=1;
		if(np<=0 && !cheat_mode)
		{
			game_over = 1;
			for(p=objects.begin();p!=objects.end();p++)
			{
				(*p)->think_fun = NULL;
				(*p)->end_move_fun = NULL;
			}
		}
		else if(na<=0)
		{
			load_map("test.map");
			score+=1000+100*stage;
		}
	}
	else
	{
		if(na<=0)
			start_demo_mode();
	}
}

