

#include "allstuff.h"



#define SNAKE_SPEED		6.0
#define PLAYER_SPEED	6.0
#define TROLL_SPEED		6.0


tObject *current_troll;




int snake_path_value(int xp,int yp)
{
	tObject *trg;
	bool cc = check_col(xp,yp,&trg);
	
	if(trg)
	{
		if(trg->id==ID_APPLE)
			return -1;
		if(trg->id==ID_SNAKE_TAIL)
			return 1000000000-trg->distance*1000;
		if(trg->id==ID_PLAYER)
			return -2;
	}
	if(cc)
		return 0;
	return 1;
}



void snake_tail_end_move(tObject *obj)
{
	remove_col(obj);
	set_col_xy(obj,round(obj->xp),round(obj->yp));
}


void snake_think(tObject *obj)
{
	obj->end_move_fun = snake_think;
	
	if(obj->next)
		set_col_xy(obj->next,round(obj->next->xp),round(obj->next->yp));


	bool go=false;
	if(obj->move_dist<0.0001)
	{
		int dir = path_find(round(obj->xp),round(obj->yp),snake_path_value);

		tObject *other = NULL;
		go=object_go(obj,dir,&other);
		if(!go && other)
		{
			if(other->id==ID_APPLE)
			{
				other->id=ID_EMPTY;
				other->frame=0;
				remove_col(other);
				go=object_go(obj,dir);
				obj->state+=3;
				if(!demo_mode)
					play_samp(3);
				
				if(!demo_mode)
					score+=90+10*stage;
			}
			else if(other->id==ID_PLAYER)
			{
				other->id = ID_EMPTY;
				other->think_fun = NULL;
				other->end_move_fun = NULL;
				other->fr_eye_l = 8;
				other->fr_eye_r = 8;
				other->fr_mouth = 5;
				play_samp(1);
			}
			else if(other->id==ID_SNAKE_TAIL)
			{
			 tObject *t = other;
			 if(t->prev) t->prev->next = NULL;
			 while(t)
			 {
				t->id = ID_EMPTY;
				t->frame = 0;
				remove_col(t);
				t->think_fun = NULL;
				t->end_move_fun = NULL;
				t=t->next;
			 }
				go=object_go(obj,dir);
			}
		}
//		if(!(go=object_go(obj,obj->move_dir)))
//			go=object_go(obj,rand()%4+1);
//		if(key[KEY_RIGHT])	go=object_go(obj,1);
//		if(key[KEY_DOWN ])	go=object_go(obj,2);
//		if(key[KEY_LEFT ])	go=object_go(obj,3);
//		if(key[KEY_UP   ])	go=object_go(obj,4);
	}

	if(go)
	{
		if(obj->state>0 /*&& !(obj->flags&FL_NEED_MOVE)*/)
		{
			tObject *tail = create_object(ID_SNAKE_TAIL,int(floor(obj->xp+0.5)),
														int(floor(obj->yp+0.5)));
			if(tail)
			{
				tail->head = obj;
				tail->next = obj->next;
				tail->prev = obj;
				if(obj->next) obj->next->prev = tail;
				obj->next = tail;

				tail->state = obj->move_dir;
				set_col_xy(tail,round(tail->xp),round(tail->yp));
			}
			obj->state--;
//			obj->flags|=FL_NEED_MOVE;
		}
		else
		{
			tObject *tail,*n;
			int d=1;
			tail=NULL;
			n=obj->next;
			while(n)
			{
				tail=n;
				n->distance = d++;
				n=n->next;
			}
			while(tail && tail!=obj)
			{
				tail->move_dir = tail->state;
				tail->move_dist = 1.0;
				tail->move_speed = SNAKE_SPEED;
				if(tail->prev!=obj)
					tail->state = tail->prev->state;
				else
					tail->state = obj->move_dir;
				remove_col(tail);
				set_col_xy(tail,round(tail->xp),round(tail->yp));
				tail=tail->prev;
			}
			obj->flags&=~FL_NEED_MOVE;
		}
	}

	obj->move_speed = SNAKE_SPEED;

	obj->frame=('s'<<8)|"00123"[obj->move_dir];
	obj->think_time=0.1;

}

int troll_path_value(int xp,int yp)
{
	tObject *trg;
	bool cc = check_col(xp,yp,&trg);
	
	if(xp==current_troll->troll_target_x-1 && yp==current_troll->troll_target_y-1)
		return -1;
		
	if(trg && trg->troll_time<15.0)
	{
		if(trg->id==ID_APPLE)
			return -(10+int(trg->troll_time));
		if(trg->id==ID_PLAYER)
			return -(10+int(trg->troll_time));
	}
	if(cc)
		return 0;
	return 1;
}


void troll_think(tObject *obj)
{
	obj->end_move_fun = troll_think;
	
	if(obj->troll_target_x==0 || (rand()%100==0) ||
		check_col(obj->troll_target_x,obj->troll_target_y,NULL) ||
		(round(obj->xp)==obj->troll_target_x-1 && round(obj->yp)==obj->troll_target_y-1))
	{
		obj->troll_target_x = rand()%25+1;
		obj->troll_target_y = rand()%25+1;
	}

	if(obj->state<4 && obj->move_dist<0.0001)
	{
		current_troll=obj;
		int dir = path_find(round(obj->xp),round(obj->yp),troll_path_value);
		tObject *other = NULL;
		if(!object_go(obj,dir,&other))
		{
			if(other && other->id==ID_APPLE)
			{
				obj->move_dir = dir;
				obj->state = 4;
				other->troll_time = 30.0;
				other->troll_dir = dir;
				other->troll_dist = 4;
				other->flags|=FL_TROLL_MOVE_START;
				play_samp(4);
			}
			else if(other && other->id==ID_PLAYER)
			{
				obj->move_dir = dir;
				obj->state = 4;
				other->troll_time = 30.0;
				other->troll_dir = dir;
				other->troll_dist = 4;
				other->end_move_fun = NULL;
				other->think_time = 5.0;
				other->state = 0;
				other->fr_eye_l = 8;
				other->fr_eye_r = 8;
				other->fr_mouth = 5;
				other->flags|=FL_TROLL_MOVE_START;
				play_samp(1);
			}
			else
				object_go(obj,rand()%4+1);
		}
//		if(key[KEY_RIGHT])	object_go(obj,1);
//		if(key[KEY_DOWN ])	object_go(obj,2);
//		if(key[KEY_LEFT ])	object_go(obj,3);
//		if(key[KEY_UP   ])	object_go(obj,4);
	}

	obj->move_speed = TROLL_SPEED;

	obj->state++;
	if(obj->state== 4) obj->state=0;
	if(obj->state==12) obj->state=0;

	obj->frame=(("drdlu"[obj->move_dir])<<8)|"010203456540"[obj->state];
	obj->think_time=(obj->state<4)?0.1:0.05;
}


void player_troll_think(tObject *obj)
{
	obj->end_move_fun = player_troll_think;
	obj->flags &= ~FL_JUMP_MOVE;

	if(obj->state<4 && obj->move_dist<0.0001)
	{
		current_troll=obj;
		int dir = 0;
		if(key[KEY_RIGHT]) dir=1;
		if(key[KEY_DOWN ]) dir=2;
		if(key[KEY_LEFT ]) dir=3;
		if(key[KEY_UP   ]) dir=4;
		tObject *other = NULL;
		if(!object_go(obj,dir,&other))
		{
			if(dir)
				obj->move_dir = dir;
			obj->state = 4;
			if(other && other->id==ID_APPLE)
			{
				other->troll_time = 30.0;
				other->troll_dir = dir;
				other->troll_dist = 4;
				other->flags|=FL_TROLL_MOVE_START;
				play_samp(4);
			}
			else if(other && other->id==ID_PLAYER)
			{
				other->troll_time = 30.0;
				other->troll_dir = dir;
				other->troll_dist = 4;
				other->end_move_fun = NULL;
				other->think_time = 5.0;
				other->state = 0;
				other->fr_eye_l = 8;
				other->fr_eye_r = 8;
				other->fr_mouth = 5;
				other->flags|=FL_TROLL_MOVE_START;
				play_samp(1);
			}
		}
		if(dir==0)
		{
			obj->state=-1;
			if(obj->state<4 && key[KEY_SPACE])
				obj->state = 4;
		}
	}

	obj->move_speed = TROLL_SPEED;

	obj->state++;
	if(obj->state== 4) obj->state=0;
	if(obj->state==12) obj->state=0;

	obj->frame=(("drdlu"[obj->move_dir])<<8)|"010203456540"[obj->state];
	obj->think_time=(obj->state<4)?0.1:0.05;
}


void apple_think(tObject *obj)
{
	obj->end_move_fun = apple_think;

	if(obj->move_dist<0.0001 && obj->troll_dist>0)
	{
		if(!object_go(obj,obj->troll_dir))
			if(obj->flags&FL_TROLL_MOVE_START)
				if(!object_go(obj,((obj->troll_dir-1+1)&3)+1))
					if(!object_go(obj,((obj->troll_dir-1-1)&3)+1))
					{
					}
		obj->flags&=~FL_TROLL_MOVE_START;

		obj->move_speed = 12.0;
		obj->troll_dist--;
	}

	obj->think_time=0.1;
}


void player_end_move(tObject *obj)
{
	obj->flags |= FL_JUMP_MOVE;
	obj->end_move_fun = player_end_move;

	if(obj->move_dist<0.0001)
	{
		bool go=false;
		if(key[KEY_RIGHT]) go=object_go(obj,1);
		if(key[KEY_DOWN ]) go=object_go(obj,2);
		if(key[KEY_LEFT ]) go=object_go(obj,3);
		if(key[KEY_UP   ]) go=object_go(obj,4);
		if(go)
			play_samp(5);
	}
	
	if(key[KEY_T] && key[KEY_R] && (high_score>=100000))
	{
		obj->id = ID_EMPTY;
		obj->fr_eye_l=0;
		obj->fr_eye_r=0;
		obj->fr_mouth=0;
		obj->state=0;
		player_troll_think(obj);
		obj->think_fun = player_troll_think;
		cheat_mode=1;
	}

	obj->move_speed = PLAYER_SPEED;
}


void player_think(tObject *obj)
{
	obj->state--;
	if(obj->state<=0)
	{
		obj->fr_eye_l = rand()%11+1;
		obj->fr_eye_r = rand()%11+1;
		obj->fr_mouth = rand()%11+1;
		obj->state = 5*(rand()%20+1);
	}

	player_end_move(obj);

	obj->frame = STR2INT("a0");
	obj->think_time=0.02;
}

